## mingw-w64-pqp-1.3-2.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(pqp)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

set(VERSION_MAJOR 1)
set(VERSION_MINOR 3)
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR})

set(
	HDRS
	src/BV.h
	src/PQP.h
	src/PQP_Compile.h
	src/PQP_Internal.h
	src/Tri.h
)

set(
	SRCS
	src/Build.cpp
	src/BV.cpp
	src/PQP.cpp
	src/TriDist.cpp
)

add_library(PQP STATIC ${HDRS} ${SRCS})

target_include_directories(
	PQP
	INTERFACE
	$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
	$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(
	PQP
	PROPERTIES
	DEBUG_POSTFIX d
	POSITION_INDEPENDENT_CODE ON
	VERSION ${VERSION}
)

install(FILES ${HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT development)

install(
	TARGETS	PQP
	EXPORT PQP
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT development
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT runtime NAMELINK_SKIP
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime
)

option(BUILD_SAMPLES "Build samples" OFF)

if(BUILD_SAMPLES)
	add_executable(sample demos/sample/main.cpp)
	target_link_libraries(sample PQP)
	
	find_package(GLUT)
	find_package(OpenGL)
	find_package(X11)
	
	if(GLUT_FOUND AND OPENGL_FOUND AND X11_FOUND)
		configure_file(demos/spinning/bunny.tris bunny.tris COPYONLY)
		configure_file(demos/spinning/torus.tris torus.tris COPYONLY)
		add_executable(spinning demos/spinning/main.cpp demos/spinning/model.cpp)
		target_include_directories(spinning PRIVATE ${GLUT_INCLUDE_DIR} ${X11_INCLUDE_DIR})
		target_link_libraries(spinning PQP ${GLUT_LIBRARIES} ${OPENGL_LIBRARIES} ${X11_LIBRARIES})
		
		configure_file(demos/falling/torus1.path torus1.path COPYONLY)
		configure_file(demos/falling/torus1.tris torus1.tris COPYONLY)
		configure_file(demos/falling/torus2.path torus2.path COPYONLY)
		configure_file(demos/falling/torus2.tris torus2.tris COPYONLY)
		add_executable(falling demos/falling/main.cpp demos/falling/model.cpp)
		target_include_directories(falling PRIVATE ${GLUT_INCLUDE_DIR} ${X11_INCLUDE_DIR})
		target_link_libraries(falling PQP ${GLUT_LIBRARIES} ${OPENGL_LIBRARIES} ${X11_LIBRARIES})
	endif()
endif()

configure_package_config_file(
	pqp-config.cmake.in pqp-config.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PQP-${VERSION}
)

install(
	FILES ${CMAKE_CURRENT_BINARY_DIR}/pqp-config.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PQP-${VERSION}
	COMPONENT development
)

write_basic_package_version_file(
	${CMAKE_CURRENT_BINARY_DIR}/pqp-config-version.cmake
	VERSION ${VERSION}
	COMPATIBILITY ExactVersion
)

install(
	FILES ${CMAKE_CURRENT_BINARY_DIR}/pqp-config-version.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PQP-${VERSION}
	COMPONENT development
)

install(
	EXPORT PQP
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PQP-${VERSION}
	NAMESPACE PQP::
	FILE pqp-export.cmake
	COMPONENT development
)

set(CPACK_COMPONENT_DEVELOPMENT_DEPENDS runtime)
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_DEVELOPMENT_PACKAGE_DEPENDS "libpqp")
set(CPACK_DEBIAN_DEVELOPMENT_PACKAGE_NAME "libpqp-dev")
set(CPACK_DEBIAN_DEVELOPMENT_PACKAGE_SECTION "libdevel")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "http://gamma.cs.unc.edu/SSV/")
set(CPACK_DEBIAN_PACKAGE_NAME "libpqp")
set(CPACK_DEBIAN_PACKAGE_SECTION "devel")
set(CPACK_DEBIAN_RUNTIME_PACKAGE_NAME "libpqp")
set(CPACK_DEBIAN_RUNTIME_PACKAGE_SECTION "libs")
set(CPACK_NSIS_PACKAGE_NAME "PQP ${VERSION}")
set(CPACK_NSIS_URL_INFO_ABOUT ${CPACK_DEBIAN_PACKAGE_HOMEPAGE})
set(CPACK_PACKAGE_CONTACT "geom@cs.unc.edu")
set(CPACK_PACKAGE_DISPLAY_NAME "PQP ${VERSION}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "PQP-${VERSION}")
set(CPACK_PACKAGE_NAME "pqp")
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE)
set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_RPM_development_PACKAGE_NAME "pqp-devel")
set(CPACK_RPM_development_PACKAGE_REQUIRES "pqp")
set(CPACK_RPM_PACKAGE_GROUP "Development/Libraries")
set(CPACK_RPM_PACKAGE_NAME "pqp")
set(CPACK_RPM_PACKAGE_URL ${CPACK_DEBIAN_PACKAGE_HOMEPAGE})
set(CPACK_RPM_runtime_PACKAGE_NAME "pqp")

if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 8)
	set(CPACK_NSIS_INSTALL_ROOT "$PROGRAMFILES64")
endif()

include(CPack)

=== Makefile ===
CC = g++

CFLAGS	= -O2 -I.

.SUFFIXES: .C .cpp

OBJECTS	= lib/PQP.o \
          lib/BV.o \
          lib/Build.o \
          lib/TriDist.o

CLEAN	= $(OBJECTS) lib/libPQP.a include/*.h

library: $(OBJECTS)
	/bin/rm -f lib/libPQP.a
	ar ruv lib/libPQP.a $(OBJECTS)
	cp src/PQP.h include/
	cp src/PQP_Compile.h include/
	cp src/PQP_Internal.h include/
	cp src/BV.h include/
	cp src/Tri.h include/

lib/BV.o: src/BV.cpp
	$(CC) $(CFLAGS) -c src/BV.cpp -o lib/BV.o
lib/PQP.o: src/PQP.cpp
	$(CC) $(CFLAGS) -c src/PQP.cpp -o lib/PQP.o
lib/Build.o: src/Build.cpp
	$(CC) $(CFLAGS) -c src/Build.cpp -o lib/Build.o
lib/TriDist.o: src/TriDist.cpp
	$(CC) $(CFLAGS) -c src/TriDist.cpp -o lib/TriDist.o

clean:
	/bin/rm -f $(CLEAN)

=== demos/Makefile ===
all: 
	cd sample; \
	make
	cd spinning; \
	make
	cd falling; \
	make

clean: 
	cd sample; \
	make clean
	cd spinning; \
	make clean
	cd falling; \
	make clean

=== demos/falling/Makefile ===
# Must set these gl and glut locations to build 'falling'

GL_INCPATH = -I/usr/local/include/
GL_LIBPATH = -L/usr/local/lib/ -L/usr/X11R6/lib/
GL_LIBS  =  -lglut -lGLU -lGL -lXext -lXmu -lXi -lX11

.SUFFIXES: .cpp

CC = g++
CFLAGS  = -O2 -I. -I../../include $(GL_INCPATH)
LDFLAGS	= -L. -L../../lib $(GL_LIBPATH)
LDLIBS  = -lPQP -lm       $(GL_LIBS) 

SRCS    = main.cpp model.cpp 

OBJECTS	= main.o model.o

TARGET = falling

CLEAN   = $(OBJECTS) $(TARGET)

.cpp.o:
	$(CC) ${CFLAGS} -c $<

$(TARGET): $(OBJECTS)
	$(CC) $(CFLAGS) -o $(TARGET) $(OBJECTS) -L. $(LDFLAGS) $(LDLIBS)

run: $(TARGET)
	$(TARGET)

clean:
	/bin/rm -f $(CLEAN)

=== demos/sample/Makefile ===
CC = g++

CFLAGS  = -O2 -I. -I../../include
LDFLAGS	= -L. -L../../lib
LDLIBS  = -lPQP -lm      

.SUFFIXES: .cpp

SRCS    = main.cpp

OBJECTS	= main.o

TARGET  = sample

CLEAN   = $(OBJECTS) $(TARGET)

.cpp.o:
	$(CC) ${CFLAGS} -c $<

$(TARGET): $(OBJECTS)
	$(CC) $(CFLAGS) -o $(TARGET) $(OBJECTS) -L. $(LDFLAGS) $(LDLIBS)

run: $(TARGET)
	$(TARGET)

clean:
	/bin/rm -f $(CLEAN)

=== demos/spinning/Makefile ===
# Must set these gl and glut locations to build 'spinning'

CC = g++

GL_INCPATH = -I/usr/include/
GL_LIBPATH = -L/usr/lib/ -L/usr/X11R6/lib/
GL_LIBS = -lGLU -lGL -lXext -lXmu -lXi -lX11 -lglut

.SUFFIXES: .cpp

CC = g++
CFLAGS  = -g -O2 -I. -I../../include $(GL_INCPATH)
LDFLAGS = -L. -L../../lib -L/usr/lib/ -L/usr/X11R6/lib/
LDLIBS  = -lPQP -lm $(GL_LIBS) 

OBJS   = main.o model.o
TARGET = spinning

.cpp.o:
	$(CC) ${CFLAGS} -c $<

$(TARGET): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o $(TARGET) $(LDFLAGS) $(LDLIBS)

run: $(TARGET)
	$(TARGET)

clean: 
	rm -f *~ $(OBJS) $(TARGET)

=== PKGBUILD ===
# Maintainer: Markus Rickert <rickert@fortiss.org>

_realname=pqp
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
_commit=713de5b70dd1849b915f6412330078a9814e01ab
pkgver=1.3
pkgrel=2
pkgdesc="A library for performing proximity queries on a pair of geometric models composed of triangles (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url="https://github.com/GammaUNC/PQP"
license=('custom')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
options=('strip' 'staticlibs')
source=("${_realname}-${pkgver}.tar.gz::https://github.com/GammaUNC/PQP/archive/${_commit}.tar.gz")
sha256sums=('ae33a4506d70b68176d4e56d60bcc5760f46cc4e71d5856c02fd82db5026457f')

build() {
  cd "${srcdir}"/PQP-${_commit}
  [[ -d "${srcdir}"/build-${CARCH} ]] && rm -rf "${srcdir}"/build-${CARCH}
  mkdir -p "${srcdir}"/build-${CARCH} && cd "${srcdir}"/build-${CARCH}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CXXFLAGS+=" -std=c++11"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${extra_config[@]}" \
    ../PQP-${_commit}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${CARCH}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --build . --target install

  install -Dm644 "${srcdir}/PQP-${_commit}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
